/*****************************************************************************
    SCRIPT PER CREAR ELS ROLS I DONAR-LIS ACCS ALS PROCEDIMENTS SEGONS
    EL ROL.
    EXECUTAR AMB PRIVILEGIS D'ADMINISTRADOR.
*****************************************************************************/
SHOW PARAMETER common_user_prefix;
--Creaci dels rols

CREATE ROLE C##encarregat;
CREATE ROLE C##USUARI;

--Permisos al rol usuari dels procediments AMB.
GRANT EXECUTE ON mrieramar.P_Alta_Departament TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_Baixa_Departament TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_Modificacio_Departament TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_ACCIOMITIGADORA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_AUDITORIAEXTERNA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_AUDITORIAINTERNA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_AUTOAVALUACIO TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_CAMPANYA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_CAT TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_EMPLEAT TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_MOSTREIG TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_ALTA_RISC TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_ACCIOMITIGADORA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_AUDITORIAEXTERNA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_AUDITORIAINTERNA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_AUTOAVALUACIO TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_CAMPANYA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_CAT TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_EMPLEAT TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_MOSTREIG TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_BAIXA_RISC TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_ACCIOMITIGADORA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_AUDITORIAEXTERNA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_AUDITORIAINTERNA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_AUTOAVALUACIO TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_CAMPANYA TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_CAT TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_EMPLEAT TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_MOSTREIG TO C##USUARI;
GRANT EXECUTE ON mrieramar.P_MODIFICACIO_RISC TO C##USUARI;
GRANT CREATE SESSION TO C##USUARI;


--Permisos al rol encarregat per els procediments de consulta.

GRANT EXECUTE ON mrieramar.P_CU11 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU12 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU13 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU14 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU15 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU16 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU17 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU18 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU19 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU20 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU21 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU22 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU23 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU24 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU25 TO C##encarregat;
GRANT EXECUTE ON mrieramar.P_CU26 TO C##encarregat;
GRANT CREATE SESSION TO C##encarregat;


--Creacio de dos usuaris per assignarlis els rols

alter session set "_ORACLE_SCRIPT"=true;

CREATE USER Pep IDENTIFIED BY 12345678
	DEFAULT TABLESPACE Data_RISC_CONTROL
	QUOTA UNLIMITED ON Data_RISC_CONTROL
	TEMPORARY TABLESPACE Temp;
    
CREATE USER Joan IDENTIFIED BY 12345678
	DEFAULT TABLESPACE Data_RISC_CONTROL
	QUOTA UNLIMITED ON Data_RISC_CONTROL
	TEMPORARY TABLESPACE Temp;    
    
--En Pep podr utilitzar els procediments AMB    
GRANT C##USUARI TO Pep;

--En Joan sera encarregat, i per tant pot modificar les dades i consultar-les.
GRANT C##encarregat TO Joan;
GRANT C##USUARI TO Joan;